<head>
    <h2 style="background-color: #495150; color: #FFFFFF; margin-bottom: -10px; font-family: Arial">ACD UHF Demo</h2>
    <hr size="5" style="background-color: #ef7d00; color: #ef7d00">
</head>
<body>
    <label style="font-family: Arial">Status: </label>
    <label id="status" style="background-color:#d51130; color: #FFFFFF; font-family: Arial" >Disconnected</label>
    <br>
    <br>
    <button id="bindModule" type="button" disabled="true" style="background-color: #d2d4d5; color: #000000; font-family: Arial">Bind UHF Module</button>
    <button id="unbindModule" type="button" disabled="true" style="background-color: #d2d4d5; color: #000000; font-family: Arial">Unbind UHF Module</button>
    <br>
    <br>
    <button id="modulePowerOn" type="button" disabled="true" style="background-color: #d2d4d5; color: #000000; font-family: Arial">Power On UHF Module</button>
    <button id="modulePowerOff" type="button" disabled="true" style="background-color: #d2d4d5; color: #000000; font-family: Arial">Power Off UHF Module</button>
    <br>
    <br>
    <button id="readerInit" type="button" disabled="true" style="background-color: #d2d4d5; color: #000000; font-family: Arial">Init UHF Reader</button>
    <button id="readerDeInit" type="button" disabled="true" style="background-color: #d2d4d5; color: #000000; font-family: Arial">Uninit UHF Reader</button>
    <br>
    <br>
    <button id="triggerScan" type="button" disabled="true" style="background-color: #d2d4d5; color: #000000; font-family: Arial">Scan Tags</button>
    <button id="stopScan" type="button" disabled="true" style="background-color: #d2d4d5; color: #000000; font-family: Arial">Stop Scan</button>
    <br>
    <br>
    <label style="font-family: Arial">Tag EPC: </label>
    <br>
    <label id="tag" style="font-family: Arial" >?</label>
    <br>
    <br>
    <label id="txtOutput" style="font-family: Arial"></label>
    <script language="javascript" type="text/javascript">

        const wsUri = "ws://127.0.0.1:56665/";
        
        var websocket;

        // UI varaiables
        var btnbindModule;
        var btnUnbindModule;
        var btnPowerOn;
        var btnPowerOff;
        var btnReaderInit;
        var btnReaderDeInit;
        var btnTriggerScan;
        var btnStopScan;
        var txtOutput;
        var txtStatus;
        var txtTag;

        // initialize the WebSocket connection to the WebAppService and setup the click listeners for the buttons 
        function init() {
            
            btnbindModule = document.getElementById("bindModule");
            btnUnbindModule = document.getElementById("unbindModule");
            btnPowerOn = document.getElementById("modulePowerOn");
            btnPowerOff = document.getElementById("modulePowerOff");
            btnReaderInit = document.getElementById("readerInit");
            btnReaderDeInit = document.getElementById("readerDeInit");
            btnTriggerScan = document.getElementById("triggerScan");
            btnStopScan = document.getElementById("stopScan");
            txtOutput = document.getElementById("txtOutput");
            txtStatus = document.getElementById("status");
            txtTag = document.getElementById("tag")

            startWebSocket();

            btnbindModule.onclick = function() {
                // send the bindModule command to the WebAppService 
                websocket.send("M2UHF.bindModule");
            };

            btnUnbindModule.onclick = function() {
                // send the unbindModule command to the WebAppService
                websocket.send("M2UHF.unbindModule");
            };

            btnPowerOn.onclick = function() {
                // send the modulePowerOn command to the WebAppService
                websocket.send("M2UHF.modulePowerOn");
            };

            btnPowerOff.onclick = function() {
                // send the modulePowerOff command to the WebAppService
                websocket.send("M2UHF.modulePowerOff");
            };

            btnReaderInit.onclick = function() {
                // send the readerInit command to the WebAppService
                websocket.send("M2UHF.readerInit");
            };

            btnReaderDeInit.onclick = function() {
                // send the readerDeInit command to the WebAppService
                websocket.send("M2UHF.readerDeInit");
            };

            btnTriggerScan.onclick = function() {

                // define the parameters for the command
                const parameters = {
                    arg1: 1
                };

                // send the readerStart command with the parameters to the WebAppService 
                websocket.send("M2UHF.readerStart." + JSON.stringify(parameters));
            };

            btnStopScan.onclick = function() {
                // send the readerStop command to the WebAppService
                websocket.send("M2UHF.readerStop");
            };
        }

        // start the web socket connetion and react to incoming data
        function startWebSocket() {
            websocket = new WebSocket(wsUri);

            websocket.onopen = function(evt) {
                // enable the bindModule button as soon as a connection to the web socket is established
                setButtonEnabled("bindModule", true);
                txtStatus.textContent = "M2UHF not bound";
                txtStatus.style = "background-color:#d51130; color: #FFFFFF; font-family: Arial"
            };

            websocket.onclose = function(evt) {
                // disable all buttons when the connection is closed
                setButtonEnabled("bindModule", false);
                setButtonEnabled("unbindModule", false);
                setButtonEnabled("modulePowerOn", false);
                setButtonEnabled("modulePowerOff", false);
                setButtonEnabled("readerInit", false);
                setButtonEnabled("readerDeInit", false);
                setButtonEnabled("triggerScan", false);
                setButtonEnabled("stopScan", false);
            };

            websocket.onmessage = function(evt) {

                // parse received data sent by the WebAppService
                var message = evt.data;

                var hardwareComponent = message.split('.', 2)[0];
                var command = message.split('.', 2)[1];
                var rawdata = '';

                // separate the data using the substring function
                var dataStartPoint = hardwareComponent.length + command.length + 2;
                if (dataStartPoint < message.length) {
                    rawdata = message.substring(dataStartPoint, message.length)
                }

                try {
                    var data = JSON.parse(rawdata);
                    // hand the parsed data to the interpret data function 
                    interpretData(hardwareComponent, command, data);
                }
                catch (error) {
                    writeToScreen("failed to parse data: " + error);
                }
            };

            websocket.onerror = function(evt) {
                writeToScreen("Communication Error: " + event.message);
            };
        }

        function interpretData(hardwareComponent, command, data) {

            // since we only interpret uhf data, we can pre-filter it here
            if (hardwareComponent == "M2UHF") {
                if(!("error" in data)) {

                    // decide what to do on what command
                    switch(command) {
                        case "moduleStatusReporter":
                            // read the bound parameter if it exists
                            if ("onModulePlugged" in data) {
                                if(data.onModulePlugged) {
                                    setButtonEnabled("bindModule", false);
                                    setButtonEnabled("unbindModule", true);
                                    setButtonEnabled("modulePowerOn", true);
                                    setButtonEnabled("modulePowerOff", false);
                                    setButtonEnabled("readerInit", false);
                                    setButtonEnabled("readerDeInit", false);
                                    setButtonEnabled("triggerScan", false);
                                    setButtonEnabled("stopScan", false);
                                    txtStatus.textContent = "Connected";
                                    txtStatus.style = "background-color:#76b72a; color: #FFFFFF; font-family: Arial"
                                }
                                else {
                                    setButtonEnabled("bindModule", true);
                                    setButtonEnabled("unbindModule", false);
                                    setButtonEnabled("modulePowerOn", false);
                                    setButtonEnabled("modulePowerOff", false);
                                    setButtonEnabled("readerInit", false);
                                    setButtonEnabled("readerDeInit", false);
                                    setButtonEnabled("triggerScan", false);
                                    setButtonEnabled("stopScan", false);
                                    txtStatus.textContent = "M2UHF not bound";
                                    txtStatus.style = "background-color:#d51130; color: #FFFFFF; font-family: Arial"
                                }
                            }
                            if("onModulePowered" in data) {
                                if(data.onModulePowered) {
                                    setButtonEnabled("bindModule", false);
                                    setButtonEnabled("unbindModule", false);
                                    setButtonEnabled("modulePowerOn", false);
                                    setButtonEnabled("modulePowerOff", true);
                                    setButtonEnabled("readerInit", true);
                                    setButtonEnabled("readerDeInit", false);
                                    setButtonEnabled("triggerScan", false);
                                    setButtonEnabled("stopScan", false);
                                }
                                else {
                                    setButtonEnabled("bindModule", false);
                                    setButtonEnabled("unbindModule", true);
                                    setButtonEnabled("modulePowerOn", true);
                                    setButtonEnabled("modulePowerOff", false);
                                    setButtonEnabled("readerInit", false);
                                    setButtonEnabled("readerDeInit", false);
                                    setButtonEnabled("triggerScan", false);
                                    setButtonEnabled("stopScan", false);
                                }
                            }
                            break;


                        case "readerInit":
                            // read the barcode parameter if it exists
                            if ("initialized" in data) {
                                if(data.initialized == "SUCCESS") {
                                    websocket.send("M2UHF.readerEnableCallback");
                                }
                            }
                            break;

                        case "readerEnableCallback":
                            // read the barcode parameter if it exists
                            if ("callbackEnabled" in data) {
                                if(data.callbackEnabled) {
                                    setButtonEnabled("bindModule", false);
                                    setButtonEnabled("unbindModule", false);
                                    setButtonEnabled("modulePowerOn", false);
                                    setButtonEnabled("modulePowerOff", false);
                                    setButtonEnabled("readerInit", false);
                                    setButtonEnabled("readerDeInit", true);
                                    setButtonEnabled("triggerScan", true);
                                    setButtonEnabled("stopScan", false);
                                }
                            }
                            break;

                        case "readerStart":
                            // read the barcode parameter if it exists
                            if ("start" in data) {
                                if(data.start == "SUCCESS") {
                                    setButtonEnabled("bindModule", false);
                                    setButtonEnabled("unbindModule", false);
                                    setButtonEnabled("modulePowerOn", false);
                                    setButtonEnabled("modulePowerOff", false);
                                    setButtonEnabled("readerInit", false);
                                    setButtonEnabled("readerDeInit", false);
                                    setButtonEnabled("triggerScan", false);
                                    setButtonEnabled("stopScan", true);
                                }
                            }
                            break;

                        case "jniReporter":
                            // read the barcode parameter if it exists
                            if ("EPC" in data && "TID" in data && "RSSI" in data) {
                                txtTag.textContent = data.EPC;
                            }
                            else if ("onAutostop" in data) {
                                if (data.onAutostop) {
                                    setButtonEnabled("bindModule", false);
                                    setButtonEnabled("unbindModule", false);
                                    setButtonEnabled("modulePowerOn", false);
                                    setButtonEnabled("modulePowerOff", false);
                                    setButtonEnabled("readerInit", false);
                                    setButtonEnabled("readerDeInit", true);
                                    setButtonEnabled("triggerScan", true);
                                    setButtonEnabled("stopScan", false);
                                    txtTag.textContent = "?";
                                }
                            }
                            break;

                        case "readerStop":
                            // read the barcode parameter if it exists
                            if ("stop" in data) {
                                if(data.stop == "SUCCESS") {
                                    setButtonEnabled("bindModule", false);
                                    setButtonEnabled("unbindModule", false);
                                    setButtonEnabled("modulePowerOn", false);
                                    setButtonEnabled("modulePowerOff", false);
                                    setButtonEnabled("readerInit", false);
                                    setButtonEnabled("readerDeInit", true);
                                    setButtonEnabled("triggerScan", true);
                                    setButtonEnabled("stopScan", false);
                                    txtTag.textContent = "?";
                                }
                            }
                            break;

                        case "readerDeInit":
                            // read the barcode parameter if it exists
                            if ("deinitialized" in data) {
                                if(data.deinitialized == "SUCCESS") {
                                    setButtonEnabled("bindModule", false);
                                    setButtonEnabled("unbindModule", false);
                                    setButtonEnabled("modulePowerOn", false);
                                    setButtonEnabled("modulePowerOff", true);
                                    setButtonEnabled("readerInit", true);
                                    setButtonEnabled("readerDeInit", false);
                                    setButtonEnabled("triggerScan", false);
                                    setButtonEnabled("stopScan", false);
                                }
                            }
                            break;

                        case "unbindModule":
                            // read the bound parameter if it exists
                            if ("commandSent" in data) {
                                if(data.commandSent) {
                                    setButtonEnabled("bindModule", true);
                                    setButtonEnabled("unbindModule", false);
                                    setButtonEnabled("modulePowerOn", false);
                                    setButtonEnabled("modulePowerOff", false);
                                    setButtonEnabled("readerInit", false);
                                    setButtonEnabled("readerDeInit", false);
                                    setButtonEnabled("triggerScan", false);
                                    setButtonEnabled("stopScan", false);
                                    txtStatus.textContent = "M2UHF not bound";
                                    txtStatus.style = "background-color:#d51130; color: #FFFFFF; font-family: Arial"
                                }
                                else {
                                    writeToScreen("Error: failed to unbind")
                                }
                            }
                            break;
                    }
                }
                else {
                    // if there is an error parameter, it will log it to the screen here
                    writeToScreen("Error in command " + command +": " + data.error);
                }
            }
        }

        // append a string to the txtOutput text field
        function writeToScreen(message) {
            var pre = document.createElement("p");
            pre.style.wordWrap = "break-word";
            pre.innerHTML = message;
            txtOutput.appendChild(pre);
        }

        function setButtonEnabled(buttonID, enabled) {
            if (enabled) {
                document.getElementById(buttonID).disabled = false;
                document.getElementById(buttonID).style = "background-color: #76b72a; color: #ffffff";
            }
            else {
                document.getElementById(buttonID).disabled = true;
                document.getElementById(buttonID).style = "background-color: #d2d4d5; color: #000000";
            }
        }

        // call the init function as soon as the window is loaded
        window.addEventListener("load", init, false);
        
    </script>
</body>